#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Outfile=C:\Users\juergen2\Desktop\open_file_picker.exe
#AutoIt3Wrapper_UseUpx=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;////

;this example sends first message to browser and exits immediatelly without waiting for answer

#include <WindowsConstants.au3>
Global $versionNum = 4 ;

Global $ExitOnFirstMessage = True ;
;//False means, the process will run permanently in listening mode and may receive messages
;//True means, the process will send the message to browser only one time and than exit immediatelly
;//never send persistent _sendPersistentMessage when $ExitOnFirstMessage = True

Global $ChannelCustomName = "WebIMECustom4" ;
;//The unique name of this program that may be accessed from parent process called by browser

Global $MaxTimes = 0 ;
;Global $GotFirstMessage = False ;

;//main body
If $ExitOnFirstMessage = True Or $ExitOnFirstMessage = False Then ;//changed since should be able to run many instances!
	;If _SingletonPID(@ScriptName & $ChannelCustomName, 1) <> 0 Then
	;	MsgBox(0, 'Error!', 'Same process ' & $ChannelCustomName & ' already exists, exit now!', 5)
	;	Exit ;
	;EndIf
;Else
	Local $ra = Random(1, 1234567890, 1) ;
	While _SingletonPID(@ScriptName & $ra & $ChannelCustomName, 1) <> 0
		$ra = Random(1, 1234567890, 1) ;
	WEnd
	$ChannelCustomName = $ra & $ChannelCustomName ;
EndIf

Global $hChild = GUICreate($ChannelCustomName)
Global $hMainWnd = WinGetHandle("WebIMEGUIChannel")
Global $Succeed = 0

While $hMainWnd = 0 And $Succeed < 4
	Sleep(3000)
	$Succeed = $Succeed + 1
	$hMainWnd = WinGetHandle("WebIMEGUIChannel")
WEnd

If $hMainWnd <> 0 Then
	GUIRegisterMsg($WM_COPYDATA, "WM_COPYDATA_ReceiveData")
	GUISetState(@SW_HIDE)

	$Succeed = 0 ;

	Local $data = "" ;

	;//you can add own functions being available inside JavaScript scope via settings.js > W.customerScripts = { }; //read important notices inside settings.js regarding W.customerScripts

	If $ExitOnFirstMessage = False Then
        ;///won't do anything
	Else
	    ;//that is only example of possible usage, this data will be sent only once and sendmsg.exe will exit after sending the message

        $data = $data & " (function() { " & @CRLF
        $data = $data & "   var window = document.defaultView || document.parentWindow; " & @CRLF
        $data = $data & "   var xfunc = function() { W.mainUploadCenter([ 0, '', '|*.pdf|', 'myRunProgHolder' ]); }; " & @CRLF
        $data = $data & "   if(!W.MB) { " & @CRLF
        $data = $data & "     if(!W.privilegedActions) { W.privilegedActions = []; } " & @CRLF
        $data = $data & "     W.privilegedActions.push(xfunc); " & @CRLF
        $data = $data & "   } else { xfunc(); } " & @CRLF
        $data = $data & " })(); " & @CRLF
	EndIf

	If $ExitOnFirstMessage = False Then
		_sendPersistentMessage($data) ;//in permanent listening mode to force the rdp channel to replay the data when browser window was refreshed, so use peristent message
	Else
		_sendSingleMessage($data) ; //when message will be sent only once, do not store it persistently to be replayed on browsers refresh, so use single message
	EndIf
Else
	MsgBox(0, "Message error!", "Channel process listener not found!", 5)
	Exit ;
EndIf

If $ExitOnFirstMessage = True Then
	While 1
		Sleep(2000)
		If $Succeed = 1 Then Exit ;
	WEnd
Else
	While 1
		Sleep(2000)
	WEnd
EndIf

Exit ;

Func WM_COPYDATA_ReceiveData($hWnd, $MsgID, $wParam, $lParam) ;
	;////
	Local $inSend = DllCall("user32.dll", "BOOLEAN", "InSendMessage") ;
	If $inSend[0] = 1 Then
		$inSend = DllCall("user32.dll", "BOOLEAN", "ReplyMessage", "uint", 1)
		;// reply to parent webime.exe process immediatelly to not make it hanging while waiting for this function to return
		;//it is Microsoft recommendation to process so, because if parent caller hangs because of waiting to return this function
		;//it will cause both processes to hang, so to avoid that and allow parent process to continue working answer with ReplyMessage as fast as possible here
		;//
		;//PS: never remove this command, else you may block the webime.exe
		;//however webime.exe uses timeout of 4 seconds and will not block forever, anyway answer with this ReplyMessage is good approach, so do not remove this command!
	EndIf
	;////

	Local $tCOPYDATA = DllStructCreate("dword;dword;ptr", $lParam)
	Local $tMsg = DllStructCreate("char[" & DllStructGetData($tCOPYDATA, 2) & "]", DllStructGetData($tCOPYDATA, 3))
	Local $received = DllStructGetData($tMsg, 1)

	If StringLeft($received, 1) = "3" Then
		$Succeed = 0 ;// just handle data without exit
		$received = StringTrimLeft($received, 1) ;
		_handleData($received)
	ElseIf $received = 0 Then
		$Succeed = 1
	EndIf
EndFunc   ;==>WM_COPYDATA_ReceiveData

Func _handleData($data)
	;$GotFirstMessage = True
    MsgBox(0, "DATA ARRIVED", $data, 5)
EndFunc   ;==>_handleData

Func WM_COPYDATA_SendData($hWnd, $sData)
	WM_COPYDATA_SendDataTimeout($hWnd, $sData, 4000)
EndFunc   ;==>WM_COPYDATA_SendData

Func WM_COPYDATA_SendDataTimeout($hWnd, $sData, $timeout)
	Local $tCOPYDATA = DllStructCreate("dword;dword;ptr")
	Local $tMsg = DllStructCreate("char[" & StringLen($sData) + 1 & "]")
	DllStructSetData($tMsg, 1, $sData)
	DllStructSetData($tCOPYDATA, 2, StringLen($sData) + 1)
	DllStructSetData($tCOPYDATA, 3, DllStructGetPtr($tMsg))
	Local $Max = 0
	$Succeed = 0
	While $Succeed <> 1 And $Max < 40
		$Max = $Max + 1
		Local $Ret = DllCall("user32.dll", "lresult", "SendMessageTimeout", "hwnd", $hWnd, "uint", $WM_COPYDATA, "wparam", 0, "lparam", DllStructGetPtr($tCOPYDATA), "uint", 0x0000, "uint", $timeout, "ptr*", 0)
		;//SendMessageTimeout gets used, because when due some wrong programming of process that retrieves this message the function should continue at least after time out elapsed
		;//however if program followed Microsofts recommendations and process replies with ReplyMessage to this call, this will continue as fast as possible
		;//
		;//PS: the parent webime.exe that represents the virtual channel follows Microsoft recommendations and replies as fast as possible to not make this function to hang
		;//however timeout of 4 seconds is good approach anyway here
		$Succeed = $Ret[0] ;
		If $Succeed = 0 Then ;// 0 means failed or timed out
			Sleep(250)
		EndIf
	WEnd
	If $Succeed = 1 Then
		;//Exit;
	Else
		MsgBox(0, "Error", "Waited more than 10 seconds for sending message!", 5);
		If $ExitOnFirstMessage = True Then Exit ;
	EndIf
EndFunc   ;==>WM_COPYDATA_SendDataTimeout

Func _sendSingleMessage($msg)
	$msg = "0" & $hChild & "@" & $msg
	WM_COPYDATA_SendData($hMainWnd, $msg)
EndFunc   ;==>_sendSingleMessage

Func _sendPersistentMessage($msg)
	If $ExitOnFirstMessage = True Then
		_sendSingleMessage($msg)
		Return
	EndIf
	$msg = "1" & $hChild & "@" & $msg
	WM_COPYDATA_SendData($hMainWnd, $msg)
EndFunc   ;==>_sendPersistentMessage

Func _SingletonPID($sOccurenceName, $iFlag = 0)
	Local $hWnd = WinGetHandle($sOccurenceName)
	If @error Then
		AutoItWinSetTitle($sOccurenceName)
		$hWnd = WinGetHandle($sOccurenceName)
		ControlSetText($hWnd, '', ControlGetHandle($hWnd, '', 'Edit1'), @AutoItPID)
	Else
		If BitAND($iFlag, 1) Then
			Return Int(ControlGetText($hWnd, '', ControlGetHandle($hWnd, '', 'Edit1')))
		Else
			Exit -1
		EndIf
	EndIf
	Return 0
EndFunc   ;==>_SingletonPID
